C
C  BULLETIN.FOR, Version 4/27/91
C  Purpose: Bulletin board utility program.
C  Environment: VAX/VMS
C  Usage: Invoked by the BULLETIN command.
C  Programmer: Mark R. London
C
C  Copyright (c) 1990
C  Property of Massachusetts Institute of Technology, Cambridge MA 02139.
C  This program cannot be copied or distributed in any form for non-MIT
C  use without specific written approval of MIT Plasma Fusion Center
C  Management.
C
	IMPLICIT INTEGER (A - Z)
 
	INCLUDE 'BULLFILES.INC'
 
	INCLUDE 'BULLDIR.INC'
 
	INCLUDE 'BULLFOLDER.INC'
 
	INCLUDE 'BULLUSER.INC'
 
	INCLUDE '($RMSDEF)'
 
	COMMON /BULLPAR/ BULL_PARAMETER,LEN_P
	CHARACTER*64 BULL_PARAMETER
 
	COMMON /POINT/ BULL_POINT
 
	COMMON /READIT/ READIT
 
	COMMON /PAGE/ PAGE_LENGTH,PAGE_WIDTH,PAGING
	LOGICAL PAGING /.FALSE./
 
	COMMON /CTRLY/ CTRLY
 
	COMMON /PROMPT/ COMMAND_PROMPT
	CHARACTER*39 COMMAND_PROMPT
 
	COMMON /ACCESS/ READ_ONLY
	LOGICAL READ_ONLY
 
	COMMON /DECNET/ DECNET_PROC,ERROR_UNIT
	LOGICAL DECNET_PROC
 
	EXTERNAL ERROR_TRAP
	EXTERNAL BULLETIN_SUBCOMMANDS,LIB$GET_INPUT
	EXTERNAL BULLETIN_MAINCOMMANDS,ENABLE_CTRL_EXIT
	EXTERNAL CLI$_ABSENT,CLI$_NOCOMD,CLI$_NEGATED
 
	PARAMETER PCB$M_BATCH = '4000'X
	PARAMETER PCB$M_NETWRK = '200000'X
	PARAMETER LIB$M_CLI_CTRLY = '2000000'X
 
	COMMON /COMMAND_LINE/ INCMD
	CHARACTER*132 INCMD
 
	CHARACTER HELP_DIRECTORY*64,SAVE_FOLDER*25
 
	COMMON /EDIT/ EDIT_DEFAULT
	DATA EDIT_DEFAULT/.FALSE./
 
	COMMON /COMMAND_SWITCHES/ LOGIN_SWITCH,SYSTEM_SWITCH
	COMMON /COMMAND_SWITCHES/ SYSTEM_LOGIN_BTIM(2)
	COMMON /COMMAND_SWITCHES/ REVERSE_SWITCH,SEPARATE
	CHARACTER*1 SEPARATE
 
	COMMON /TAGS/ BULL_TAG,READ_TAG
 
	COMMON /DEF_PROT/ ORIGINAL_DEF_PROT
 
	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT
 
	COMMON /PROMPT_PROMPT/ PROMPT,LPROMPT
	CHARACTER*42 PROMPT
 
	CHARACTER DCL_CMD*132
 
	CALL LIB$GET_FOREIGN(INCMD)
	DCL_COMMAND = INDEX(INCMD,' "').GT.0.OR.INCMD(:1).EQ.'"'
 
	CALL LIB$ESTABLISH(ERROR_TRAP)
        IF (.NOT.CLI$GET_VALUE('PROMPT',COMMAND_PROMPT,ILEN)) THEN
           CALL LIB$REVERT
           CALL CLI$GET_VALUE('$LINE',COMMAND_PROMPT,ILEN)
	   INCMD = 'BULLETIN '//INCMD
           CALL CLI$DCL_PARSE(INCMD,BULLETIN_MAINCOMMANDS)
        ELSE
           CALL LIB$REVERT
        END IF
 
	IF (DCL_COMMAND) THEN
	   IER = CLI$GET_VALUE('SELECT_FOLDER',DCL_CMD,LENP)
	   IF (LENP.GT.0) THEN
	      IF (DCL_CMD(LENP:LENP).EQ.'"') DCL_CMD = DCL_CMD(:LENP-1)
	      IF (DCL_CMD(:1).EQ.'"') DCL_CMD = DCL_CMD(2:)
	   END IF
	END IF
 
	READIT = 0
 
	LOGIN_SWITCH = CLI$PRESENT('LOGIN')
	SYSTEM_SWITCH = CLI$PRESENT('SYSTEM')
	REVERSE_SWITCH = CLI$PRESENT('REVERSE')
 
	IER = LIB$SYS_TRNLOG('BULL_DISABLE',LEN_P,BULL_PARAMETER)
	IF (IER.EQ.1.AND.LEN_P.GT.0.AND..NOT.CLI$PRESENT('STOP')) THEN
	   IF (.NOT.LOGIN_SWITCH) THEN
	      WRITE (6,'('' BULLETIN temporarily disabled. Try later.'')')
	   END IF
	   CALL EXIT
	END IF
 
	CALL SYS$SETDFPROT(,ORIGINAL_DEF_PROT)
		! Save original default protection in case it gets changed
 
	CALL DCLEXH(%LOC(ENABLE_CTRL_EXIT))		! Declare exit handler
 
C
C  Check to see if CONTROL Y disabled.  If so, then never disable CONTROL Y.
C  Disabling and enabling CONTROL Y is done so that a person can not break
C  while one of the data files is opened, as that would not allow anyone
C  else to modify the files.  However, if CONTROL Y is already disabled,
C  this is not necessary, and should not be done!
C
 
	CALL LIB$DISABLE_CTRL(LIB$M_CLI_CTRLY,CTRLY)	! Disable CTRL-Y & -C
	CTRLY = CTRLY .AND. LIB$M_CLI_CTRLY
	CALL GETPRIV				! Check privileges
	CALL CHECK_PRIV_IO(ERR)			! Check privileges on output I/O
	CALL LIB$ENABLE_CTRL(CTRLY,)		! Renable CTRLY-Y & -C
 
	IF (ERR.EQ.1) CALL EXIT			! I/O privilege error, so exit
 
	CALL GETUSER(USERNAME)		! Get the process's username
	IF (.NOT.LOGIN_SWITCH) CALL CHECK_BULLETIN_PRIV(USERNAME)
					! Check if has bulletin privileges
 
	I = 1				! Strip off folder name if specified
	DO WHILE (I.LE.ILEN)
	   IF (COMMAND_PROMPT(I:I).EQ.' ') THEN
	      COMMAND_PROMPT = COMMAND_PROMPT(:I-1)
	      I = ILEN + 1
	   ELSE
	      I = I + 1
	   END IF
	END DO
	ILEN = 1			! Get executable name to use as prompt
	DO WHILE (ILEN.GT.0)
	   ILEN = MAX(INDEX(COMMAND_PROMPT,':'),INDEX(COMMAND_PROMPT,']'))
	   IF (ILEN.GT.0) THEN
	      COMMAND_PROMPT = COMMAND_PROMPT(ILEN+1:)
	   ELSE
	      DO I=TRIM(COMMAND_PROMPT),1,-1
		 IF (COMMAND_PROMPT(I:I).LT.'A'.OR.
     &			COMMAND_PROMPT(I:I).GT.'Z') THEN
		    COMMAND_PROMPT = COMMAND_PROMPT(:I-1)
		 END IF
	      END DO
	   END IF
	END DO
	COMMAND_PROMPT = COMMAND_PROMPT(:TRIM(COMMAND_PROMPT))//'> '
	IF (COMMAND_PROMPT.EQ.'RUN> '.OR.COMMAND_PROMPT.EQ.'RU> '.OR.
     &	    COMMAND_PROMPT.EQ.'R> ') COMMAND_PROMPT = 'BULLETIN> '
 
	FOLDER_FILE = FOLDER_DIRECTORY(:TRIM(FOLDER_DIRECTORY))//FOLDER
 
	CALL CLI$GET_VALUE('SEPARATE',SEPARATE)
 
	IF (CLI$PRESENT('EDIT')) EDIT_DEFAULT = .TRUE.	! /EDIT switch test
 
	CALL FIND_BULLCP			! See if BULLCP is running
 
	IF (CLI$PRESENT('CLEANUP')) THEN	! Test for /CLEANUP switch
	   CALL CLI$GET_VALUE('CLEANUP',BULL_PARAMETER,LEN_P) ! Get folder #
	   READ (BULL_PARAMETER,'(I<LEN_P>)') FOLDER_NUMBER
	   CALL SELECT_FOLDER(.FALSE.,IER)	! Select folder
	   CALL CLEANUP_BULLFILE		! Cleanup empty blocks
	   CALL EXIT				! all done with cleanup
	ELSE IF (CLI$PRESENT('BBOARD')) THEN	! Test for /BBOARD switch
	   CALL BBOARD				! look for BBOARD mail
	   CALL EXIT				! all done with BBOARD
	ELSE IF (CLI$PRESENT('STARTUP').OR.	! BULLCP process control
     &	         CLI$PRESENT('STOP')) THEN
	   CALL CREATE_BULLCP
	ELSE IF (CLI$PRESENT('BULLCP')) THEN	! This is BULLCP, so start
	   IF (.NOT.CLI$GET_VALUE('SELECT_FOLDER',
     &				BULL_PARAMETER,LENP)) THEN
	      CALL RUN_BULLCP			! doing what BULLCP does!
	   ELSE IF (BULL_PARAMETER(:LENP).EQ.'NEWS') THEN
	      CALL NEWS2BULL
	   END IF
	END IF
 
	CALL GETSTS(STS)			! Get process status word
 
	IF (SYSTEM_SWITCH.OR.LOGIN_SWITCH) THEN	! If BULLETIN/LOGIN or /SYSTEM
	   IF ((STS.AND.PCB$M_BATCH).GT.0) CALL EXIT	! If BATCH, exit
	   CALL CRELNM('SYS$INPUT','TT')	! Take input from terminal
	END IF
 
	IF ((STS.AND.PCB$M_NETWRK).EQ.0) THEN
	   DECNET_PROC = .FALSE.
	   ERROR_UNIT = 6
 
	   CALL ASSIGN_TERMINAL			! Assign terminal
 
	   IF (.NOT.LOGIN_SWITCH) THEN
	      INCMD = 'SELECT'	! Causes nearest folder name to be selected
	      CALL SELECT_FOLDER(.FALSE.,IER)	! Select GENERAL folder
	      IF (.NOT.IER) RETURN			! If can't access, exit
 
	      IF (.NOT.TEST_BULLCP()) CALL DELETE_EXPIRED
						! Delete expired messages
	   END IF
 
C
C  Get page size for the terminal.
C
 
	   CALL GETPAGSIZ(PAGE_LENGTH,PAGE_WIDTH)
 
	   IER = CLI$GET_VALUE('WIDTH',BULL_PARAMETER,LEN_P)
	   IF (IER.NE.%LOC(CLI$_ABSENT)) THEN
	      DECODE(LEN_P,'(I<LEN_P>)',BULL_PARAMETER) PAGE_WIDTH
	   END IF
 
	   IF (CLI$PRESENT('PAGE')) PAGING = .TRUE.
 
	   IF (SYSTEM_SWITCH) THEN
	      IER = CLI$GET_VALUE('SYSTEM',BULL_PARAMETER,LEN_P)
	      IF (IER.NE.%LOC(CLI$_ABSENT)) THEN	! Days specified?
	         CALL SUBTIME(SYSTEM_LOGIN_BTIM,BULL_PARAMETER(:LEN_P),IER)
		 IF (.NOT.IER) THEN
		    WRITE (6,'('' ERROR: Invalid parameter in /SYSTEM.'')')
		    CALL EXIT
		 END IF
	      END IF
	      IF (.NOT.LOGIN_SWITCH) THEN
	         CALL MODIFY_SYSTEM_LIST(0)
		 CALL SHOW_SYSTEM
	         CALL EXIT
	      END IF
	   END IF
 
C
C  Get user info stored in SYS$LOGIN.  Currently, this simply stores
C  the time of the latest message read for each folder.
C
 
	   CALL OPEN_USERINFO
 
C
C  If /LOGIN, display SYSTEM bulletins and subject of non-SYSTEM bulletins.
C
 
	   IF (LOGIN_SWITCH.OR.SYSTEM_SWITCH) THEN	! Is /LOGIN present?
	      CALL LOGIN			! Display SYSTEM bulletins
	      IF (READIT.EQ.0) CALL EXIT	! If no READNEWs not set, exit
	   END IF
 
C
C  If new bulletins have been added since the last time bulletins have beeni
C  read, position bulletin pointer so that next bulletin read is the first new
C  bulletin, and alert user.  If READNEW set and no new bulletins, just exit.
C
 C
	   IF (.NOT.DCL_COMMAND) CALL NEW_MESSAGE_NOTIFICATIONe
  
	   CALL OPEN_OLD_TAGA
 1
	ELSE 
	   IF (TEST_BULLCP()) CALL EXIT
	   DECNET_PROC = .TRUE.
	   ERROR_UNIT = 5
	END IFe
 i
Cr
C  The MAIN loop for processing bulletin commands.
Cn
 
	DIR_COUNT = 0	! # directory entry to continue bulletin read fromI
	READ_COUNT = 0	! # block that bulletin READ is to continue from
	FOLDER_COUNT = 0 ! # folder entry to continue SHOW/ALL folder fromL
	INDEX_COUNT = 0
 A
	IER = LIB$SYS_TRNLOG('BULL_HELP',HLEN,HELP_DIRECTORY)
	IF (IER.NE.1) THEN/
	   HELP_DIRECTORY = 'SYS$HELP:'
	   HLEN = 9
	ELSE IF (HELP_DIRECTORY(HLEN:HLEN).NE.':'.AND.O
     &		 HELP_DIRECTORY(HLEN:HLEN).NE.']') THENO
	   HELP_DIRECTORY = HELP_DIRECTORY(:HLEN)//':'A
	   HLEN = HLEN + 1G
	END IF_
 Y
	LPROMPT = TRIM(COMMAND_PROMPT)C
	PROMPT = CHAR(10)//COMMAND_PROMPT(:LPROMPT)//' 'R
	LPROMPT = LPROMPT + 2
 N
	DO WHILE (1)B
 T
	   IF (.NOT.DCL_COMMAND) THEN
	      CALL COMMAND_INPUT(IER)
	   ELSE
	      IF (INDEX(DCL_CMD,';').GT.0) THEN
	         INCMD = DCL_CMD(:INDEX(DCL_CMD,';')-1)
	         DCL_CMD = DCL_CMD(INDEX(DCL_CMD,';')+1:)
	      ELSEM
	         INCMD = DCL_CMDC
	         DCL_CMD = ' 'C
	      END IFI
	      IER = TRIM(INCMD)
	   END IF
 E
	   IF (IER.EQ.-2) THEN 
	      IER = RMS$_EOF
	   ELSE IF (IER.LE.0) THEN/
	      IER = %LOC(CLI$_NOCOMD)
	   ELSE
	      DO WHILE (IER.GT.0.AND.INCMD(:1).EQ.' ')M
		 INCMD = INCMD(2:IER)I
		 IER = IER - 1
	      END DOT
	      IF (IER.GT.0.AND.INCMD(:1).GE.'0'.AND.INCMD(:1).LE.'9') THENI
		 INCMD = 'READ '//INCMDR
	      END IFE
	      IER=CLI$DCL_PARSE(INCMD,BULLETIN_SUBCOMMANDS,LIB$GET_INPUT)
	   END IF
 M
	   IF (IER.EQ.RMS$_EOF) THEN
	      CALL EXIT			! If no command, exit
	   ELSE IF (IER.EQ.%LOC(CLI$_NOCOMD)) THEN  ! If just RETURN enteredL
	      LEN_P = 0			! Indicate no parameter in commandT
	      IF (DIR_COUNT.GT.0) THEN		! If still more dir entries
		 CALL DIRECTORY(DIR_COUNT)	! continue outputting them 
	      ELSE IF (INDEX_COUNT.GT.0) THEN
	         CALL FULL_DIR(INDEX_COUNT)
	      ELSE IF (FOLDER_COUNT.GT.0) THEN	! If more folder entries
		 CALL DIRECTORY_FOLDERS(FOLDER_COUNT) ! continue outputting them
	      ELSE				! Else try to read next bulletin 
		 CALL READ_MSG(READ_COUNT,BULL_POINT+1)  ! or finish old one
	         DIR_COUNT = 0"
	         FOLDER_COUNT = 0
	         INDEX_COUNT = 0A
	      END IFL
	      GO TO 100				! Loop to read new command
	   ELSE IF (.NOT.IER) THEN		! If command has errorS
	      GO TO 100				! ask for new commandB
	   END IF
 N
           IER = MIN(INDEX(INCMD(:TRIM(INCMD)),' '),INDEX(INCMD,'/'))S
	   IF (IER.GT.0) INCMD = '    '//INCMD(IER:)	! Save qualifiers(
	   CALL CLI$GET_VALUE('$VERB',INCMD(:4))	! Get user's command. 
 A
	   IF (INCMD(:4).EQ.'BACK'.AND.DIR_COUNT.NE.0) THEN
	      DIR_COUNT = -1i
	      CALL DIRECTORY(DIR_COUNT)
	      INCMD = ' '
C	   ELSE IF (INCMD(:4).EQ.'BACK'.AND.FOLDER_COUNT.NE.0) THEN
C	      FOLDER_COUNT = -1N
C	      CALL DIRECTORY_FOLDERS(FOLDER_COUNT)
C	      INCMD = ' 'g
	   ELSE
	      DIR_COUNT = 0			! Reinit display pointers
	      READ_COUNT = 0 
	      FOLDER_COUNT = 0t
	      INDEX_COUNT = 0
	   END IF
 m
	   IF (READ_ONLY.AND.(INCMD(:3).EQ.'ADD'.OR.INCMD(:3).EQ.'DEL't
     &	     .OR.INCMD(:3).EQ.'CHA'.OR.INCMD(:3).EQ.'REP')) THEN$
						! FOLDER can only be read?
	     WRITE (6,'('' ERROR: Access to folder limited to reading.'')')
	   ELSE IF (INCMD(:3).EQ.'ADD') THEN	! ADD?
	     IF (REMOTE_SET.GE.3) THENn
		INCMD = 'POST'
		CALL RESPOND(MAIL_STATUS)R
	     ELSE
	        CALL ADDE
	     END IF
	   ELSE IF (INCMD(:3).EQ.'ATT') THEN	! ATTACH? 
	     CALL ATTACH!
	   ELSE IF (INCMD(:4).EQ.'BACK') THEN	! BACK?
	     IF (BULL_POINT.LE.1) THENE
	        WRITE(6,1060)
	     ELSE
	        CALL READ_MSG(READ_COUNT,BULL_POINT-1)  ! Try to read previousL
	     END IF
	   ELSE IF (INCMD(:4).EQ.'CHAN') THEN		! CHANGE?C
	     CALL REPLACE				! Replace old bulletin
	   ELSE IF (INCMD(:4).EQ.'COPY') THEN		! COPY? 
	     CALL MOVE(.FALSE.)
	   ELSE IF (INCMD(:4).EQ.'CREA') THEN		! CREATE?I
	     CALL CREATE_FOLDER			! Go create the folder)
	   ELSE IF (INCMD(:4).EQ.'CURR') THEN		! CURRENT?
	     READ_COUNT = -1		! Reread current message from beginning. 
	     CALL READ_MSG(READ_COUNT,BULL_POINT)
	   ELSE IF (INCMD(:4).EQ.'DELE') THEN 	! DELETE?P
	     CALL DELETE_MSG			! Go delete bulletin
	   ELSE IF (INCMD(:4).EQ.'DIRE') THEN		! DIRECTORY?
	     IF (CLI$PRESENT('FOLDER').OR.		! /FOLDER specified?M
     &		 CLI$PRESENT('NEWS')) THEN		! or /NEWS?'
		CALL DIRECTORY_FOLDERS(FOLDER_COUNT)	! Show all foldersP
	     ELSE IF (CLI$PRESENT('SELECT_FOLDER')) THEN! Folder specified?
	        CALL SELECT_FOLDER(.TRUE.,IER)		! Try to select folder_
	        IF (IER) THEN				! If successfulE
	           CALL DIRECTORY(DIR_COUNT)		! Show messages
		END IF
	     ELSE
	        CALL DIRECTORY(DIR_COUNT)		! Show messages'
	     END IF
	   ELSE IF (INCMD(:4).EQ.'FILE'.OR.
     &		    INCMD(:4).EQ.'EXTR') THEN		! FILE?
	     CALL FILE				! Copy bulletin to file
	   ELSE IF (INCMD(:1).EQ.'E'.OR.S
     &		    INCMD(:4).EQ.'QUIT') THEN		! EXIT?
	     CALL EXIT				! Exit from program
	   ELSE IF (INCMD(:4).EQ.'HELP') THEN		! HELP?
	     CALL HELP(HELP_DIRECTORY(:HLEN)//'BULL.HLB')	! Get help
	   ELSE IF (INCMD(:3).EQ.'IND') THEN		! INDEX? 
	     INDEX_COUNT = 1 
	     CALL FULL_DIR(INDEX_COUNT)
	   ELSE IF (INCMD(:4).EQ.'LAST') THEN		! LAST?&
	     READ_COUNT = -1S
	     BULL_READ = 99999E
	     CALL READ_MSG(READ_COUNT,BULL_READ))
	   ELSE IF (INCMD(:4).EQ.'MARK') THEN		! MARK?I
	     CALL TAG(.TRUE.)
	   ELSE IF (INCMD(:4).EQ.'MAIL') THEN		! MAIL? 
	     CALL MAIL(MAIL_STATUS)
	   ELSE IF (INCMD(:3).EQ.'MOD') THEN		! MODIFY?
	     CALL MODIFY_FOLDER
	   ELSE IF (INCMD(:4).EQ.'MOVE') THEN		! MOVE?E
	     CALL MOVE(.TRUE.) 
	   ELSE IF (INCMD(:4).EQ.'NEWS') THEN		! NEWS
	     CALL DIRECTORY_FOLDERS(FOLDER_COUNT)	! Show new foldersB
	   ELSE IF (INCMD(:4).EQ.'NEXT'.OR.INCMD(:1).EQ.'N') THEN    ! NEXT?,
	     CALL READ_MSG(READ_COUNT,BULL_POINT+1)	! Read next bulletin_
	   ELSE IF (INCMD(:4).EQ.'POST') THEN		! POST? 
	     CALL RESPOND(MAIL_STATUS)S
	   ELSE IF (INCMD(:4).EQ.'PRIN') THEN		! PRINT?
	     CALL PRINT				! Printout bulletinE
	   ELSE IF (INCMD(:4).EQ.'READ') THEN		! READ?
	     IER = CLI$GET_VALUE('BULLETIN_NUMBER',BULL_PARAMETER,LEN_P) 
	     IF (IER.NE.%LOC(CLI$_ABSENT)) THEN		! Bulletin specified? 
	        DECODE(LEN_P,'(I<LEN_P>)',BULL_PARAMETER) BULL_READ	! Yes
		READ_COUNT = -1
		CALL READ_MSG(READ_COUNT,BULL_READ)a
	     ELSE
		CALL READ_MSG(READ_COUNT,BULL_POINT+1)
	     END IF
	   ELSE IF (INCMD(:3).EQ.'REM') THEN		! REMOVE?
	     CALL REMOVE_FOLDER
	   ELSE IF (INCMD(:3).EQ.'REP') THEN		! REPLY?_
	     IF (REMOTE_SET.GE.3) THENF
		CALL RESPOND(MAIL_STATUS)G
	     ELSE
	        CALL REPLY(
	     END IF
	   ELSE IF (INCMD(:3).EQ.'RES') THEN		! RESPOND?R
	     CALL RESPOND(MAIL_STATUS).
	   ELSE IF (INCMD(:3).EQ.'SEA') THEN		! SEARCH?
	     CALL SEARCH(READ_COUNT)T
	   ELSE IF (INCMD(:3).EQ.'SEL') THEN		! SELECT?
	     CALL SELECT_FOLDER(.TRUE.,IER)
	   ELSE IF (INCMD(:3).EQ.'SET') THEN		! SET?
	     CALL CLI$GET_VALUE('SET_PARAM1',BULL_PARAMETER)T
	     IF (BULL_PARAMETER(:1).EQ.'F') THEN		! SET FOLDER?
		CALL SELECT_FOLDER(.TRUE.,IER)
	     ELSE IF (BULL_PARAMETER(:3).EQ.'PRI') THEN		! SET PRIVS?
		CALL SET_PRIVt
	     ELSE IF (BULL_PARAMETER(:2).EQ.'PA') THEN		! SET PAGE?
		PAGING = .TRUE.
		WRITE (6,'('' PAGE has been set.'')') 
	     ELSE IF (BULL_PARAMETER(:1).EQ.'K') THEN		! SET KEYPAD?b
		CALL SET_KEYPAD
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOK') THEN		! SET NOKEYPAD? 
		CALL SET_NOKEYPADi
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOPA') THEN	! SET NOPAGE? 
		PAGING = .FALSE.
		WRITE (6,'('' NOPAGE has been set.'')') 
	     ELSE IF (FOLDER_NUMBER.EQ.-1.AND.REMOTE_SET.EQ.1) THEN
	        WRITE (6,'('' ERROR: Invalid command for remote folder.'')')n
	     ELSE IF (BULL_PARAMETER(:2).EQ.'SY') THEN		! SET SYSTEM?
	 	CALL SET_SYSTEM(.TRUE.)
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOSY') THEN	! SET NOSYSTEM?A
	 	CALL SET_SYSTEM(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:2).EQ.'BB') THEN		! SET BBOARD?
		CALL SET_BBOARD(.TRUE.)i
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOBB') THEN	! SET NOBBOARD?D
		CALL SET_BBOARD(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:2).EQ.'DU') THEN		! SET DUMP?
		CALL SET_FOLDER_FLAG(.TRUE.,1,'DUMP')
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NODU') THEN	! SET NODUMP?o
		CALL SET_FOLDER_FLAG(.FALSE.,1,'DUMP')
	     ELSE IF (BULL_PARAMETER(:2).EQ.'ST') THEN		! SET STRIP? 
		CALL SET_FOLDER_FLAG(.TRUE.,4,'STRIP')
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOST') THEN	! SET NOSTRIP?
		CALL SET_FOLDER_FLAG(.FALSE.,4,'STRIP')E
	     ELSE IF (BULL_PARAMETER(:2).EQ.'DI') THEN		! SET DIGEST?
		CALL SET_FOLDER_FLAG(.TRUE.,5,'DIGEST')M
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NODI') THEN	! SET NODIGEST?=
		CALL SET_FOLDER_FLAG(.FALSE.,5,'DIGEST')
	     ELSE IF (BULL_PARAMETER(:2).EQ.'AL') THEN		! SET ALWAYS?
		CALL SET_FOLDER_FLAG(.TRUE.,7,'ALWAYS')N
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOAL') THEN	! SET NOALWAYS?M
		CALL SET_FOLDER_FLAG(.FALSE.,7,'ALWAYS')
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOTI') THEN	! SET NOTIFY? 
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))T
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(1,-1,-1) 
		ELSE
		   CALL SET_USER_FLAG(1,-1,-1)
		END IF
	     ELSE IF (BULL_PARAMETER(:1).EQ.'E') THEN	! SET EXPIRE?
	        IER = CLI$GET_VALUE('EXPIRATION',BULL_PARAMETER,LEN_P)=
		IF (LEN_P.LE.3) THEN
	           READ (BULL_PARAMETER,'(I<LEN_P>)') LIMIT
		   CALL SET_FOLDER_EXPIRE_LIMIT(LIMIT)
		ELSE
		   WRITE (6,'('' ERROR: Invalid expiration specified.'')')
		END IF
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NODE') THEN	! SET NODE?
		CALL SET_NODE(.TRUE.)c
	     ELSE IF (BULL_PARAMETER(:6).EQ.'NONODE') THEN	! SET NONODE? 
		CALL SET_NODE(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOE') THEN	! SET NOEXPIRE?
		CALL SET_FOLDER_EXPIRE_LIMIT(0) 
	     ELSE IF (BULL_PARAMETER(:5).EQ.'NONOT') THEN	! SET NONOTIFY?
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))o
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(0,-1,-1)I
		ELSE
		   CALL SET_USER_FLAG(0,-1,-1)
		END IF
	     ELSE IF (BULL_PARAMETER(:1).EQ.'S') THEN		! SET SHOWNEW?
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))1
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,0,1)
		ELSE
		   CALL SET_USER_FLAG(-1,0,1),
		END IF
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOS') THEN	! SET NOSHOWNEW?i
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT')) 
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,0,0)
		ELSE
		   CALL SET_USER_FLAG(-1,0,0)(
		END IF
	     ELSE IF (BULL_PARAMETER(:1).EQ.'R') THEN		! SET READNEW?
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))n
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,1,0)
		ELSE
		   CALL SET_USER_FLAG(-1,1,0) 
		END IF
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOR') THEN	! SET NOREADNEW?O
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))l
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,0,0)
		ELSE
		   CALL SET_USER_FLAG(-1,0,0)G
		END IF
	     ELSE IF (BULL_PARAMETER(:2).EQ.'BR') THEN		! SET BRIEF? 
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))E
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,1,1)
		ELSE
		   CALL SET_USER_FLAG(-1,1,1) 
		END IF
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOBR') THEN	! SET NOBRIEF?
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT')):
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,0,0)
		ELSE
		   CALL SET_USER_FLAG(-1,0,0) 
		END IF
	     ELSE IF (BULL_PARAMETER(:1).EQ.'A') THEN		! SET ACCESS? 
		CALL SET_ACCESS(.TRUE.)	
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOA') THEN	! SET NOACCESS?
		CALL SET_ACCESS(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:1).EQ.'C') THEN	! SET CONTINUOUS_BRIEFE
		CALL SET_BRIEF_CONTINUOUS(.TRUE.)d
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOC') THEN	! SET NOCONTINUOUS_BRIEF 
		CALL SET_BRIEF_CONTINUOUS(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:1).EQ.'G') THEN		! SET GENERIC?
		CALL SET_GENERIC(.TRUE.)
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOG') THEN	! SET NOGENERIC?T
		CALL SET_GENERIC(.FALSE.)f
	     ELSE IF (BULL_PARAMETER(:1).EQ.'L') THEN		! SET LOGIN?
		CALL SET_LOGIN(.TRUE.)
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOL') THEN	 ! SET NOLOGIN?
		CALL SET_LOGIN(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:3).EQ.'PRO') THEN	 ! SET PROMPT_EXPIRE?
		CALL SET_FOLDER_FLAG(.FALSE.,3,'PROMPT_EXPIRE')&
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOPR') THEN ! SET NOPROMPT_EXPIRE?
		CALL SET_FOLDER_FLAG(.TRUE.,3,'PROMPT_EXPIRE')
	     ELSE IF (BULL_PARAMETER(:3).EQ.'DEF') THEN	! SET DEFAULT_EXPIRE?
		CALL SET_DEFAULT_EXPIREI
	     END IF
	   ELSE IF (INCMD(:4).EQ.'SHOW') THEN		! SHOW?O
	     CALL CLI$GET_VALUE('SHOW_PARAM1',BULL_PARAMETER,LEN_P)
	     IF (BULL_PARAMETER(:2).EQ.'FL') THEN	! SHOW FLAGS?
		CALL SHOW_FLAGSN
	     ELSE IF (BULL_PARAMETER(:2).EQ.'FO') THEN	! SHOW FOLDER?
	        CALL SHOW_FOLDERA
	     ELSE IF (BULL_PARAMETER(:1).EQ.'K') THEN	! SHOW KEYPAD
	        CALL SHOW_KEYPAD(HELP_DIRECTORY(:HLEN)//'BULL.HLB')
	     ELSE IF (BULL_PARAMETER(:1).EQ.'N') THEN	! SHOW NEW?
		SAVE_FOLDER_NUMBER = FOLDER_NUMBER
		SAVE_FOLDER = FOLDER
		CALL NEW_MESSAGE_NOTIFICATIONO
		FOLDER1 = SAVE_FOLDER:
		FOLDER_NUMBER = SAVE_FOLDER_NUMBER
		CALL SELECT_FOLDER(.FALSE.,IER)D
	     ELSE IF (BULL_PARAMETER(:1).EQ.'P') THEN	! SHOW PRIVILEGES?O
		CALL SHOW_PRIV
	     ELSE IF (BULL_PARAMETER(:1).EQ.'U') THEN	! SHOW USER? 
	        CALL SHOW_USERA
	     ELSE IF (BULL_PARAMETER(:1).EQ.'V') THEN	! SHOW VERSION?
		CALL SHOW_VERSION.
	     END IF
           ELSE IF (INCMD(:4).EQ.'SPAW') THEN           ! SPAWN command?
             CALL SPAWN_PROCESSI
           ELSE IF (INCMD(:3).EQ.'SUB') THEN            ! SUBSCRIBE command?
             CALL SUBSCRIBEL
	   ELSE IF (INCMD(:4).EQ.'UNDE') THEN		! UNDELETE?E
	     CALL UNDELETEH
	   ELSE IF (INCMD(:3).EQ.'UNM') THEN		! UNMARK?
	     CALL TAG(.FALSE.)E
           ELSE IF (INCMD(:3).EQ.'UNS') THEN            ! UNSUBSCRIBE command?
             CALL UNSUBSCRIBED
	   END IF
 N
100	   CONTINUEF
  
	   IF (DCL_COMMAND.AND.TRIM(DCL_CMD).EQ.0) CALL EXITA
 R
	END DOD
 
1010	FORMAT(Q,A)
1060	FORMAT(' ERROR: There are no more preceding messages.')
 
	END
 S
 D
 I
	SUBROUTINE COMMAND_INPUT(IER)
 L
	IMPLICIT INTEGER (A - Z) 
 E
	COMMON /COMMAND_LINE/ INCMD
	CHARACTER*132 INCMD
 R
	COMMON /PROMPT_PROMPT/ PROMPT,LPROMPT
	CHARACTER*42 PROMPT
 A
	CALL GET_INPUT_PROMPT(INCMD,IER,PROMPT(:LPROMPT))
 D
	RETURNS
 )
	END
 S
 C
 
  
 A
	SUBROUTINE ADD.
CE
C  SUBROUTINE ADD 
CC
C  FUNCTION: Adds bulletin to bulletin file.
CT
	IMPLICIT INTEGER (A - Z)R
 T
	COMMON /POINT/ BULL_POINT
 :
	COMMON /BULLPAR/ BULL_PARAMETER,LEN_P
	CHARACTER*64 BULL_PARAMETER
 L
	COMMON /NODE_INFO/ NODES,LOCAL_NODE_FOUND,NODE_NUM,
     &				NODE_ERROR,POINT_NODE 
	CHARACTER*32 NODES(10)A
	LOGICAL LOCAL_NODE_FOUND,NODE_ERROR
 
	COMMON /DECNET/ DECNET_PROC,ERROR_UNIT
	LOGICAL DECNET_PROC
 E
	COMMON /EDIT/ EDIT_DEFAULTE
	DATA EDIT_DEFAULT/.FALSE./ 
  
	COMMON /COMMAND_LINE/ INCMD
	CHARACTER*132 INCMD
 P
	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT
 A
	COMMON /LAST_RECORD_WRITTEN/ OCOUNT
 
	INCLUDE 'BULLDIR.INC'
  
	INCLUDE 'BULLUSER.INC'e
 '
	INCLUDE 'BULLFOLDER.INC'_
 B
	CHARACTER INEXDATE*11,INEXTIME*11
	CHARACTER*(LINE_LENGTH) INDESCRIP
 o
	CHARACTER INLINE*80,OLD_FOLDER*25,LOCAL_NODE*8L
 A
	EXTERNAL CLI$_ABSENT,CLI$_NEGATED
 ?
	EDITIT = (CLI$PRESENT('EDIT').OR.EDIT_DEFAULT).AND.
     &           (CLI$PRESENT('EDIT').NE.%LOC(CLI$_NEGATED))
 A
	IF (CLI$PRESENT('EXTRACT').AND..NOT.EDITIT) THENT
	   WRITE (6,'('' ERROR: Cannot extract text without /EDIT.'')')
	   RETURN
	END IFO
 )
	CALL DISABLE_CTRL		! Disable CTRL-Y & -CF
 E
	ALLOW = SETPRV_PRIV()
 A
	OLD_FOLDER_NUMBER = FOLDER_NUMBER
	OLD_FOLDER = FOLDER
 .
	LEN_P = 0
 
	IF (CLI$PRESENT('EXTRACT')) THEN.
	   BULL_PARAMETER = 'SYS$LOGIN:BULL.SCR'F
	   LEN_P = TRIM(BULL_PARAMETER)
	   OPEN(UNIT=3,FILE=BULL_PARAMETER(:LEN_P),IOSTAT=IER, 
     &		RECL=LINE_LENGTH,R
     &		STATUS='NEW',CARRIAGECONTROL='LIST',FORM='FORMATTED')E
  
	   IF (IER.NE.0) THEN
	      CALL ERRSNS(IDUMMY,IER)
	      CALL SYS_GETMSG(IER)E
	      GO TO 910
	   END IF
 ?
	   CALL OPEN_BULLFIL_SHARED
 ,
	   ILEN = LINE_LENGTH + 1
 _
	   CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)	
	   IF (ILEN.GT.0.AND.INPUT(:6).EQ.'From: ') THENE
	      CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)
	   END IF
	   IF (ILEN.GT.0.AND.INPUT(:6).EQ.'Subj: ') THENL
	      CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)
	   END IF
 _
	   DO WHILE (ILEN.GT.0)			! Copy bulletin into file
	      IF (CLI$PRESENT('NOINDENT')) THEN
	         WRITE (3,'(A)') INPUT(:ILEN)
	      ELSE 
	         WRITE (3,'(A)') '>'//INPUT(:ILEN)S
	      END IFT
	      CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)
	   END DO
 L
90	   CALL CLOSE_BULLFIL
	END IF)
 	
	IF (CLI$PRESENT('FILESPEC')) THEN
	   IER = CLI$GET_VALUE('FILESPEC',BULL_PARAMETER,LEN_P)
	   CALL DISABLE_PRIVS
	   IF (.NOT.CLI$PRESENT('EXTRACT')) THEN 
	      OPEN (UNIT=3,FILE=BULL_PARAMETER(:LEN_P),STATUS='OLD',E
     &		READONLY,SHARED,ERR=920,FORM='FORMATTED'),
	   ELSE
	      OPEN (UNIT=4,FILE=BULL_PARAMETER(:LEN_P),STATUS='OLD',B
     &		READONLY,SHARED,ERR=920,FORM='FORMATTED')A
	      IER = 0
	      ICOUNT = 0 
	      DO WHILE (IER.EQ.0)
		 READ (4,'(Q,A)',IOSTAT=IER) ILEN,INPUTF
		 IF (IER.EQ.0) THENB
		    IF (ICOUNT.EQ.0) WRITE (3,'(A)') ' '
		    ICOUNT = ICOUNT + 1I
		    WRITE (3,'(A)') INPUT(:ILEN)
		 END IF.
	      END DON
	      CLOSE (UNIT=4)(
	      BULL_PARAMETER = 'SYS$LOGIN:BULL.SCR'
	      LEN_P = TRIM(BULL_PARAMETER)T
	   END IF
	   CALL ENABLE_PRIVS	! Reset SYSPRV privilegesL
	END IFD
 D
	SELECT_FOLDERS = .FALSE.	
	IF (CLI$PRESENT('SELECT_FOLDER')) THEN
	   CALL GET_FOLDER_INFO(IER)1
	   IF (.NOT.IER) GO TO 910?
	   SELECT_FOLDERS = .TRUE.)
	ELSE$
	   NODE_NUM = 1
	   NODES(1) = OLD_FOLDERP
	END IF)
 .
	IF (FOLDER_NUMBER.GT.0.AND.		! If folder set and 
     &	    CLI$PRESENT('NODES')) THEN		! Decnet nodes specified?
	   WRITE (6,'('' ERROR: /NODES cannot be used with folder set.'')')
	   GO TO 910i
	END IFL
 R
	IF (.NOT.BTEST(FOLDER_FLAG,2).AND.FOLDER_NUMBER.NE.0.AND.
     &	   (CLI$PRESENT('SYSTEM').OR.		! Is /SYSTEM switch present?
     &	    CLI$PRESENT('BROADCAST').OR.	! Is /BROADCAST swtich present?(
     &	    CLI$PRESENT('SHUTDOWN'))) THEN	! Is /SHUTDOWN switch present?
	   WRITE (6,'('' ERROR: Folder is not a SYSTEM folder.'')')
	   GO TO 910 
	END IFN
 P
	IF (CLI$PRESENT('SYSTEM')) THEN		! Is /SYSTEM switch present?
	   IF (.NOT.ALLOW) THEN			! If no privileges 
	      WRITE(ERROR_UNIT,1070)		! Tell user
	      GO TO 910				! and abort'
	   END IF
	   SYSTEM = 1				! Set system bit
	ELSET
	   SYSTEM = 0				! Clear system bit
	END IFR
 N
	IF (CLI$PRESENT('BROADCAST')) THEN	! Is /BROADCAST switch present? 
	   IF (.NOT.(ALLOW.OR.OPER_PRIV())) THEN	! If no privileges
	      WRITE(ERROR_UNIT,1080)		! Tell user
	      GO TO 910				! and abortT
	   ELSE IF (CLI$PRESENT('CLUSTER')) THENL
	      SYSTEM = SYSTEM.OR.8	
	   END IF
	END IFA
 T
	IF (CLI$PRESENT('PERMANENT')) THEN	! Is /PERMANENT switch present?O
	   IF (F_EXPIRE_LIMIT.GT.0.AND..NOT. ! Expiration limit present
     &		FOLDER_ACCESS(USERNAME,FOLDER_FLAG,FOLDER_OWNER)) THEN
	      WRITE(ERROR_UNIT,1083)F
	      GO TO 910
	   ELSE
	      SYSTEM = SYSTEM.OR.2		! Set permanent bit
	      INEXDATE = '5-NOV-2000'
	      INEXTIME = '00:00:00.00'D
	   END IF
	END IFE
 	
	IF (CLI$PRESENT('SHUTDOWN')) THEN	! Is /SHUTDOWN switch present?E
	   IF (.NOT.ALLOW) THEN			! If no privilegesT
	      WRITE(ERROR_UNIT,1082)		! Tell user
	      GO TO 910				! and abortC
	   ELSE
	      IER = CLI$GET_VALUE('SHUTDOWN',INLINE)A
	      IF (IER.NE.%LOC(CLI$_ABSENT)) THENE
		 IF (REMOTE_SET) THEN		! Can't specify node name if 
		    WRITE (6,1090)		! remote folder, as no codeU
		    GO TO 910			! present to send the name.
		 END IFI
	         CALL GET_NODE_NUMBER_OTHER(NODE_NUMBER,NODE_AREA,INLINE)
		 IF (NODE_AREA.EQ.0) GO TO 910	! Invalid node name
	      ELSEN
	         CALL GET_NODE_NUMBER(NODE_NUMBER,NODE_AREA) 
	      END IF(
	      SYSTEM = SYSTEM.OR.4		! Set shutdown bit.
	      INEXDATE = '5-NOV-2000'
	      WRITE (INEXTIME,'(I4)') NODE_NUMBER
	      WRITE (INEXTIME(7:),'(I4)') NODE_AREA
	      DO I=1,11
		 IF (INEXTIME(I:I).EQ.' ') INEXTIME(I:I) = '0'
	      END DO3
	      INEXTIME = INEXTIME(1:2)//':'//INEXTIME(3:4)//':'//
     &			 INEXTIME(7:8)//'.'//INEXTIME(9:10)
	   END IF
	END IFP
 P
	SELECT_NODES = .FALSE. 
	IF (CLI$PRESENT('NODES')) THENN
	   CALL GET_NODE_INFO
	   IF (NODE_ERROR) GO TO 940 
	   SELECT_NODES = .TRUE.D
	END IFS
 '
	IF ((SYSTEM.AND.7).LE.1) THEN		! Not permanent or shutdown_
	   CALL GET_EXPIRED(INPUT,IER)P
	   IF (.NOT.IER) GO TO 910S
	   INEXDATE = INPUT(:11)G
	   INEXTIME = INPUT(13:)A
	END IF.
 '
	IF (INCMD(:3).EQ.'REP') THEN		! REPLY?H
	   INDESCRIP = DESCRIP			! Use description with RE:,H
	   LENDES = TRIM(INDESCRIP)		! filled in by main subroutine
	ELSE IF (CLI$PRESENT('SUBJECT')) THEN	! /SUBJECT specifiedH
	   CALL CLI$GET_VALUE('SUBJECT',INDESCRIP,LENDES)
	ELSEE
	   WRITE(6,1050)			! Request header for bulletin
	   CALL GET_LINE(INDESCRIP,LENDES)	! Get input line
	   IF (LENDES.LE.0) GO TO 910
	END IFR
 
	LENDES = MIN(LEN(INDESCRIP)-6,LENDES)	! Make room for "Subj: "O
 	
CL
C  If file specified in ADD command, read file to obtain bulletin.
C  Else, read the bulletin from the terminal.B
C_
 A
	IF (EDITIT.AND..NOT.DECNET_PROC) THEN	! If /EDIT specified
	   IF (LEN_P.EQ.0) THEN			! If no file param specifiedE
	      CALL MAILEDIT('SYS$LOGIN:BULL.SCR',' ')
	      OPEN (UNIT=3,FILE='SYS$LOGIN:BULL.SCR',STATUS='OLD', 
     &		 DISPOSE='DELETE',ERR=910,FORM='FORMATTED')S
	      LEN_P = 1
	   ELSE
	      CLOSE (UNIT=3)N
	      CALL MAILEDIT(BULL_PARAMETER(:LEN_P),'SYS$LOGIN:BULL.SCR')E
	      IF (CLI$PRESENT('EXTRACT')) THEN 
	         CONTEXT = 0(
	         CALL LIB$FIND_FILE('SYS$LOGIN:BULL.SCR',INPUT,CONTEXT)
	         VERSION = INDEX(INPUT,';') + 1
	         IF (INPUT(VERSION:VERSION).EQ.'1') THEND
	            CALL LIB$DELETE_FILE('SYS$LOGIN:BULL.SCR;*')0
	         END IF
	      END IFe
	      OPEN (UNIT=3,FILE='SYS$LOGIN:BULL.SCR',STATUS='OLD',M
     &		 DISPOSE='DELETE',ERR=910,FORM='FORMATTED')C
	   END IF
	END IFI
 D
	ICOUNT = 0				! Line count for bulletin
 R
	IF (LEN_P.GT.0) THEN			! If file param in ADD command
	   DO WHILE(1)				! Read until end of file to
	      READ (3,'(Q,A)',END=10) ILEN,INPUT! get record count
	      IF (ILEN.GT.LINE_LENGTH) GO TO 950u
	      ICOUNT = ICOUNT + 1 + MIN(ILEN,80)E
	      IF (ILEN.EQ.0) ICOUNT = ICOUNT + 1! COPY_BULL writes line withL
	   END DO				! 1 space for blank line
	ELSE					! If no input file
	   OPEN (UNIT=3,STATUS='SCRATCH',FILE='SYS$LOGIN:BULL.SCR',
     &		FORM='FORMATTED',RECL=LINE_LENGTH) ! Temp file to save message
	   WRITE (6,1000)			! Request input from terminal
	   ILEN = LINE_LENGTH + 1		! Length of input line
	   ICOUNT = 0				! Character count counterA
	   DO WHILE (ILEN.GE.0)			! Input until no more input
	      CALL GET_LINE(INPUT,ILEN)		! Get input line
	      IF (ILEN.GT.LINE_LENGTH) THEN	! Input line too long
		 WRITE(6,'('' ERROR: Input line length > '',I,
     &			''.  Reinput:'')') LINE_LENGTH1
	      ELSE IF (ILEN.GE.0) THEN		! If good input line enteredO
		 ICOUNT = ICOUNT + ILEN		! Update counter$
		 WRITE(3,2010) INPUT(:ILEN)	! Save line in scratch file.
	      END IFN
	   END DO
	   IF (ILEN.EQ.-1) GO TO 910		! CTRL_C entered, error out
10	   IF (ICOUNT.EQ.0) GO TO 910		! No lines entered, error out'
	ENDIF
 n
	REWIND (UNIT=3)
 o
	IF (SELECT_NODES.AND.NODE_NUM.GT.0) THENC
	   INLINE = 'ADD'
	   IF (CLI$PRESENT('SYSTEM'))
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/SYSTEM'
	   IF (CLI$PRESENT('BROADCAST'))C
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/BROADCAST'
	   IF (CLI$PRESENT('PERMANENT')) 
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/PERMANENT'_
	   IF (CLI$PRESENT('SHUTDOWN'))
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/SHUTDOWN'
	   IF (CLI$PRESENT('BELL'))
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/BELL'
 O
	   LEN_INLINE = STR$POSITION(INLINE,' ') - 1+
 
	   DO POINT_NODE=1,NODE_NUM	   	! Write out command to nodesL
	      INLINE = INLINE(:LEN_INLINE)E
 
	      WRITE (POINT_NODE+9,'(A)',ERR=940) INLINE
	      IF ((SYSTEM.AND.7).LE.1)N
				! If not permanent or shutdown specify dateU
     &		WRITE (POINT_NODE+9,'(A)',ERR=940) INEXDATE//' '//INEXTIME
	      WRITE (POINT_NODE+9,'(A)',ERR=940) INDESCRIP(:LENDES)
	      IER = 0
	      DO WHILE (IER.EQ.0)
	         READ (3,'(Q,A)',IOSTAT=IER) ILEN,INPUT
		 ILEN = MIN(ILEN,LINE_LENGTH)I
		 IF (IER.EQ.0) THENL
		    WRITE (POINT_NODE+9,'(A)',ERR=940) INPUT(:ILEN)A
		 END IFL
	      END DO
	      WRITE (POINT_NODE+9,'(A)',ERR=940) CHAR(26)
	      READ (POINT_NODE+9,'(A)',ERR=940,END=940) INPUT
	      IF (INPUT.EQ.'END') THENE
	         WRITE (6,'('' Message successfully sent to node '',A)')N
     &				NODES(POINT_NODE)E
	      ELSE,
	         WRITE (6,'('' Error while sending message to node '',A)')A
     &				NODES(POINT_NODE)B
		 WRITE (6,'(A)') INPUT(:80)2
		 GO TO 940
	      END IFI
	      REWIND (UNIT=3)
	   END DO
	END IFI
 E
	IF (SELECT_NODES.AND..NOT.LOCAL_NODE_FOUND) GO TO 95 
					! Exit if local node not specified.
 E
	IF (.NOT.SELECT_FOLDERS) THEN
	   NODE_NUM = 1				! No folders specified so just
	   NODES(1) = FOLDER			! add to select folder
	END IFL
 A
	IER = SYS_TRNLNM('SYS$NODE',LOCAL_NODE)
	LNODE = TRIM(LOCAL_NODE)	
	LUSER = TRIM(USERNAME)L
 R
C	
C  Add bulletin to bulletin file and directory entry for to directory file.I
CE
	BRDCST = .FALSE.'
 T
	DO I = 1,NODE_NUM
 E
	   IF (FOLDER.NE.NODES(I)) THEN
	      FOLDER_NUMBER = -1S
	      FOLDER1 = NODES(I)E
	      CALL SELECT_FOLDER(.FALSE.,IER)
	   ELSE
	      IER = 1
	   END IF
	   
	   IF (IER) THEN
	      CALL OPEN_BULLDIR			! Prepare to add dir entryp
 f
	      DESCRIP=INDESCRIP(:LENDES)	! Description header
	      EXDATE=INEXDATE			! Expiration date
	      EXTIME=INEXTIME
	      FROM = USERNAME			! UsernameN
 
	      CALL OPEN_BULLFIL			! Prepare to add bulletin
  
	      CALL READDIR(0,IER)		! Get NBLOCK
	      IF (IER.EQ.0) NBLOCK = 0		! If new file, NBLOCK is 0E
 '
	      REWIND (UNIT=3)
	      OBLOCK = NBLOCK+1
	      CALL STORE_BULL(LNODE+LUSER+6,'From: '//o
     &		 LOCAL_NODE(:LNODE)//USERNAME(:LUSER),OBLOCK)E
	      IF (LENDES.GT.LEN(DESCRIP)) THENr
	         CALL STORE_BULL(LENDES+6,I
     &			'Subj: '//INDESCRIP(:LENDES),OBLOCK)	
	      END IF 
	      CALL COPY_BULL(3,1,OBLOCK,IER)	! Add the new bulletin
	      IF (IER.NE.0) GO TO 930		! Error in creating bulletin
	      LENGTH = OCOUNT - (NBLOCK+1) + 1S
C)
C  Broadcast the bulletin if requested. 
CF
	      IF (.NOT.BRDCST.AND.CLI$PRESENT('BROADCAST').AND.
     &		 (.NOT.REMOTE_SET.OR.FOLDER_NUMBER.GT.0)) THEN
		 CALL GET_BROADCAST_MESSAGE(CLI$PRESENT('BELL'))
		 BRDCST = .TRUE.
	         IF (.NOT.CLI$PRESENT('LOCAL')) THEN
	            CALL BROADCAST_ALL_NODES(CLI$PRESENT('ALL'),p
     &			CLI$PRESENT('CLUSTER'))
		 END IFT
	         CALL BROADCAST(t
     &			CLI$PRESENT('ALL'),CLI$PRESENT('CLUSTER'))W
	      END IF 
 W
	      CALL CLOSE_BULLFIL		! Finished adding bulletin 
 S
	      CALL ADD_ENTRY			! Add the new directory entryT
  
	      IF (FOLDER_NUMBER.GE.0) THEN0
	         DIFF = COMPARE_BTIM(LAST_READ_BTIM(1,FOLDER_NUMBER+1),
     &			       F_NEWEST_BTIM)
	         CALL UPDATE_FOLDER		! Update info in folder file
CI
C  If user is adding message, an no new messages, update last read time for
C  folder, so user is not alerted of new message which is owned by user.
CB
	         IF (DIFF.GE.0) THEN)
	            LAST_READ_BTIM(1,FOLDER_NUMBER+1) = F_NEWEST_BTIM(1)e
	            LAST_READ_BTIM(2,FOLDER_NUMBER+1) = F_NEWEST_BTIM(2)
	         END IF
	      END IFN
 _
	      CALL CLOSE_BULLDIR		! Totally finished with add
	   ELSE
	      WRITE (6,'('' ERROR: Unable to add message to '',A)')
     &				NODES(I)
	   END IF
	END DO 
  
95	CLOSE (UNIT=3)			! Close the input file
	IF (DECNET_PROC) WRITE(5,'(''END'')') ! DECNET operation worked
 E
100	CALL ENABLE_CTRL		! Enable CTRL-Y & -C
	DO I=10,NODE_NUM+9A
	   CLOSE (UNIT=I)
	END DOE
 M
	IF (FOLDER_NUMBER.NE.OLD_FOLDER_NUMBER) THEND
	   FOLDER_NUMBER = OLD_FOLDER_NUMBER'
	   FOLDER1 = OLD_FOLDER
	   CALL SELECT_FOLDER(.FALSE.,IER)9
	END IF 
  
	IF (CLI$PRESENT('EXTRACT')) THENF
	   CALL LIB$DELETE_FILE('SYS$LOGIN:BULL.SCR;*')
	END IF_
 O
	RETURN(
 E
910	WRITE(ERROR_UNIT,1010)
	CLOSE (UNIT=3,ERR=100)I
	GOTO 100 
 Y
920	WRITE(ERROR_UNIT,1020)
	CALL ENABLE_PRIVS
	GOTO 100A
 G
930	WRITE (ERROR_UNIT,1025)F
	CALL CLOSE_BULLFILS
	CALL CLOSE_BULLDIRT
	CLOSE (UNIT=3)I
	GO TO 100
 A
940	WRITE (6,1015) NODES(POINT_NODE)
	WRITE (6,1018)H
	CLOSE (UNIT=3) 
	GO TO 100
  
950	WRITE (6,1030) LINE_LENGTH
	CLOSE (UNIT=3)I
	GO TO 100
  
1000	FORMAT (' Enter message: End with ctrl-z, cancel with ctrl-c') 
1010	FORMAT (' No message was added.')
1015	FORMAT (' ERROR: Unable to reach node ',A)	
1018	FORMAT (' Try using /FOLDER instead of /NODE.')
1020	FORMAT (' ERROR: Unable to open specified file.')
1025	FORMAT (' ERROR: Unable to add message to file.')
1030	FORMAT (' ERROR: Line length in file exceeds '',I,'' characters.')m
1050	FORMAT (' Enter description header.')
1070	FORMAT (' ERROR: SETPRV privileges are needed for system.
     & messages.')
1080	FORMAT (' ERROR: SETPRV privileges are needed to broadcast 
     & messages.')
1082	FORMAT (' ERROR: SETPRV privileges are needed to shutdown
     & messages.')
1083	FORMAT (' ERROR: Folder has expiration limit.')
1090	FORMAT (' ERROR: Nodename cannot be specified for shutdown(
     & if folder is remote.')B
2010	FORMAT(A)
2020	FORMAT(1X,A)L
 C
	END
  
 I
	SUBROUTINE SUBTIME(BTIM,DAYS_BEFORE_TODAY,IER)X
  
	IMPLICIT INTEGER (A-Z)N
 I
	CHARACTER DAYS_BEFORE_TODAY*(*),TODAY_DATE*23
 E
	INTEGER BTIM(2),TODAY_BTIM(2)
  
	IER = SYS$BINTIM(DAYS_BEFORE_TODAY,BTIM)D
	IF (.NOT.IER) RETURN$
 E
	BTIM(1) = -BTIM(1)		! Convert to negative delta time 
	BTIM(2) = -BTIM(2)-1 
 I
	IER = SYS$ASCTIM(TLEN,TODAY_DATE,,)
	CALL SYS$BINTIM(TODAY_DATE(:TLEN),TODAY_BTIM)
 M
	CALL LIB$SUBX(TODAY_BTIM,BTIM,BTIM)
 N
	RETURN!
	END
 n
 o
 u
	SUBROUTINE BROADCAST_ALL_NODES(ALL,CLUSTER)
 a
	IMPLICIT INTEGER (A-Z)W
 E
	INCLUDE 'BULLUSER.INC'f
 l
	INCLUDE 'BULLFOLDER.INC''
 D
	PARAMETER BRDCST_LIMIT = 82*12 + 2 
	CHARACTER*(BRDCST_LIMIT) BMESSAGE
 u
	COMMON /BROAD_MESSAGE/ BMESSAGE,BLENGTH
 
	COMMON /SYSTEM_FOLDERS/ SYSTEM_FLAG(FLONG),NODENAME
	CHARACTER NODENAME*8N
 O
	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT
 u
	CHARACTER LOCALNODE*8,RESPONSE*1R
 H
	IF (.NOT.TEST_BULLCP().OR.REMOTE_SET) RETURNM
 E
	CALL OPEN_BULLUSER_SHARED
 e
	REMOTE_FOUND = .FALSE.T
	TEMP_USER = ':'
 t
	DO WHILE (.NOT.REMOTE_FOUND)=
	   DO WHILE (REC_LOCK(IER))		 u
	      READ (4,KEYGT=TEMP_USER,IOSTAT=IER)
     &		TEMP_USER,LOGIN_BTIM,READ_BTIM,NEW_FLAGl
	   END DO
	   IF (TEMP_USER(:1).NE.':') THEN
	      CALL CLOSE(4)
	      RETURNT
 	   END IF 
	   REMOTE_FOUND = TEST2(NEW_FLAG,FOLDER_NUMBER)
	END DOn
 e
	CALL CLOSE (4) 
 	
100	OPEN (UNIT=17,STATUS='UNKNOWN',IOSTAT=IER,RECL=256,.
     &		FILE=NODENAME(:TRIM(NODENAME))//'::"TASK=BULLETIN1"')E
 !
	IF (IER.EQ.0) THENW
	   IER = 0I
	   I = 1	
	   DO WHILE (IER.EQ.0.AND.I.LT.BLENGTH)
	      WRITE (17,'(4A)',IOSTAT=IER)O
     &		15,-1,I,BMESSAGE(I:MIN(BLENGTH,I+127))
	       I = I + 1280
	   END DO
	   IF (IER.EQ.0) WRITE (17,'(7A)',IOSTAT=IER)
     &		15,BLENGTH,I,ALL,CLUSTER,FOLDER_NUMBER,FOLDER 
	ELSE=
	   WRITE (6,'('' BULLCP not responding to request to'',
     &	              '' broadcast to other nodes.'')')
	   CALL GET_INPUT_PROMPT(RESPONSE,LEN, 
     &		'Want to try again? (Y/N with Y as default): ')A
	   IF (RESPONSE.NE.'n'.AND.RESPONSE.NE.'N') THEN 
	      WRITE (6,'('' Trying again...'')'))
	      GO TO 100
	   ELSE
	      WRITE (6,'('' Broadcast aborting. '',
     &		         ''Continuing with message addition.'')')(
	   END IF
	END IF
  
	CLOSE (UNIT=17)
 I
	RETURNO
	END
 L
 ,
 )
 /
	INTEGER FUNCTION ERROR_TRAP
 R
	ERROR_TRAP = 1'
  
	RETURN
	END
 I
 N
 =
	SUBROUTINE REPLYi
 o
	IMPLICIT INTEGER (A - Z) 
 L
	COMMON /POINT/ BULL_POINT
 
	COMMON /BULLPAR/ BULL_PARAMETER,LEN_P
	CHARACTER*64 BULL_PARAMETER
 7
	INCLUDE 'BULLDIR.INC'
 a
	IF (BULL_POINT.EQ.0) THEN	! If no bulletin has been read,
	   WRITE(6,'('' ERROR: You have not read any message.'')')O
	   RETURN			! And returnI
	END IF)
  
	CALL OPEN_BULLDIR_SHAREDL
 I
	CALL READDIR(BULL_POINT,IER)	! Get info for specified bulletinE
  
	IF (IER.NE.BULL_POINT+1) THEN	! Was bulletin found?
	   WRITE(6,'('' ERROR: Bulletin was not found.'')')
	   CALL CLOSE_BULLDIR		! If not, then error out
	   RETURN
	END IF2
 
	CALL CLOSE_BULLDIRD
 ,
	WRITE (6,'('' Adding REPLY message with the subject:'')')
	CALL STR$UPCASE(BULL_PARAMETER,DESCRIP)
	IF (BULL_PARAMETER(:3).NE.'RE:') THEN
	   DESCRIP = 'RE: '//DESCRIP,
	ELSE 
	   DESCRIP = 'RE:'//DESCRIP(4:)
	END IFg
	WRITE (6,'(1X,A)') DESCRIP	
 E
	CALL ADDE
 
	RETURN(
	END
 I
 T
 0
 
	SUBROUTINE CRELNM(INPUT,OUTPUT)
	R
	IMPLICIT INTEGER (A-Z)O
 E
	INCLUDE '($PSLDEF)'
 O
	INCLUDE '($LNMDEF)'
 O
	CHARACTER*(*) INPUT,OUTPUTf
 c
	CALL INIT_ITMLSTe
	CALL ADD_2_ITMLST(LEN(OUTPUT),LNM$_STRING,%LOC(OUTPUT))
	CALL END_ITMLST(CRELNM_ITMLST)
  
	IER = SYS$CRELNM(,'LNM$PROCESS',INPUT,PSL$C_USER,
     &		%VAL(CRELNM_ITMLST))
 '
	RETURND
	END
 E
 T
 (
	SUBROUTINE GETPRIV=
CI
C  SUBROUTINE GETPRIV 
Cd
C  FUNCTION:
C	To get process privileges.
C  OUTPUTS:e
C	PROCPRIV - Returned privileges
C
 
	IMPLICIT INTEGER (A-Z) 
 F
	COMMON /PRIVILEGES/ PROCPRIV(2),NEEDPRIV(2)
 =
	COMMON /REALPROC/ REALPROCPRIV(2)
  
	INCLUDE '($JPIDEF)'
 E
	CALL INIT_ITMLST	! Initialize item list
	CALL ADD_2_ITMLST(8,JPI$_PROCPRIV,%LOC(PROCPRIV))
	CALL END_ITMLST(GETJPI_ITMLST)	! Get address of itemlistR
 :
	IER = SYS$GETJPIW(,,,%VAL(GETJPI_ITMLST),,,,) ! Get infop
 t
	REALPROCPRIV(1) = PROCPRIV(1)
	REALPROCPRIV(2) = PROCPRIV(2)
 m
	RETURN 
	END
  
 N
 L
 L
	LOGICAL FUNCTION SETPRV_PRIV 
	IMPLICIT INTEGER (A-Z)E
 	
	COMMON /PRIVILEGES/ PROCPRIV(2),NEEDPRIV(2)
	DATA NEEDPRIV/0,0/K
  
	INCLUDE '($PRVDEF)'
 I
	INCLUDE 'BULLUSER.INC'O
 1
	INCLUDE 'BULLFILES.INC'
 E
	IF (NEEDPRIV(1).EQ.0.AND.NEEDPRIV(2).EQ.0) THEN
	   CALL OPEN_BULLUSER_SHARED		! Get BULLUSER.DAT file
	   CALL READ_USER_FILE_HEADER(IER)L
	   CALL CLOSE_BULLUSERu
	   NEEDPRIV(1) = USERPRIV(1)K
	   NEEDPRIV(2) = USERPRIV(2) 
	END IF(
 ,
	IF ((PROCPRIV(1).AND.NEEDPRIV(1)).NE.0.OR. 
     &	    (PROCPRIV(2).AND.NEEDPRIV(2)).NE.0) THEN 
	   SETPRV_PRIV = .TRUE.
	ELSE 
	   SETPRV_PRIV = .FALSE.b
	END IFf
 q
	RETURN
	END
  
  
 O
	LOGICAL FUNCTION OPER_PRIVA
	IMPLICIT INTEGER (A-Z)N
	COMMON /PRIVILEGES/ PROCPRIV(2),NEEDPRIV(2)
	INCLUDE '($PRVDEF)'
	OPER_PRIV = BTEST(PROCPRIV(1),PRV$V_OPER)
	RETURN 
	END
 N
 C
 P
	SUBROUTINE GETUSER(USERNAME) 
C 
C  SUBROUTINE GETUSERE
CL
C  FUNCTION:
C	To get username of present process.
C  OUTPUTS: 
C	USERNAME   -   Username owner of present process.,
C$
 S
	IMPLICIT INTEGER (A-Z)E
 I
	INCLUDE '($PRVDEF)'
 _
	CHARACTER*(*) USERNAME		! Limit is 12 charactersL
 D
	INCLUDE '($JPIDEF)'
 i
	CALL INIT_ITMLST	! Initialize item list
	CALL ADD_2_ITMLST(LEN(USERNAME),JPI$_USERNAME,%LOC(USERNAME))
	CALL END_ITMLST(GETJPI_ITMLST)	! Get address of itemlist 
 L
	IER = SYS$GETJPIW(,,,%VAL(GETJPI_ITMLST),,,,) ! Get infor
  
	RETURNs
	END
 n
 e
        SUBROUTINE SPAWN_PROCESS
 
	IMPLICIT INTEGER (A - Z) 
 r
	INCLUDE 'BULLUSER.INC'i
 w
	INCLUDE '($UAIDEF)'
  
	COMMON /KEYPAD/ KEYPAD_MODE
  
	CHARACTER*255 COMMAND
 N
	DATA CAPTIVE /0/_
 M
	IF (CAPTIVE.EQ.0) THENE
	   CALL INIT_ITMLST	! Initialize item list
	   CALL ADD_2_ITMLST(4,UAI$_FLAGS,%LOC(FLAGS))L
	   CALL END_ITMLST(GETUAI_ITMLST)	! Get address of itemlist
           IER = SYS$GETUAI(,,USERNAME,%VAL(GETUAI_ITMLST),,,)
	   CAPTIVE = 1N
	   IF ((FLAGS.AND.UAI$M_CAPTIVE).NE.0) CAPTIVE = -1
	END IF
  
	IF (CAPTIVE.EQ.-1) THEN
	   WRITE (6,'('' ERROR: SPAWN not allowed from CAPTIVE account.'')')C
	   RETURN
	END IFN
 _
	CALL DISABLE_PRIVSI
 )
	SAVE_KEYPAD_MODE = KEYPAD_MODER
	IF (KEYPAD_MODE.EQ.0) CALL SET_KEYPAD
 M
	IF (CLI$PRESENT('COMMAND')) THENR
	   CALL CLI$GET_VALUE('COMMAND',COMMAND,CLEN)
	   COMMAND = '$'//COMMAND(:CLEN)T
	   CALL LIB$SPAWN(COMMAND(:CLEN+1))
	ELSE'
           CALL LIB$SPAWN()I
	END IFR
 R
	IF (SAVE_KEYPAD_MODE.EQ.0) CALL SET_NOKEYPADT
 E
	CALL ENABLE_PRIVS
 Y
	RETURNT
        END1
 )
 C
        SUBROUTINE ATTACHA
 G
	IMPLICIT INTEGER (A - Z)5
 
	COMMON /KEYPAD/ KEYPAD_MODE
 _
	COMMON /TERM_CHAN/ TERM_CHAN 
 1
	INCLUDE '($JPIDEF)'
 )
	CHARACTER*15 PROCESSI
 (
	IF (CLI$PRESENT('PROCESS')) THEN1
	   CALL CLI$GET_VALUE('PROCESS',PROCESS,PLEN)
 T
	   CALL INIT_ITMLST	! Initialize item lists
	   CALL ADD_2_ITMLST(4,JPI$_PID,%LOC(PROCESS_ID))
	   CALL END_ITMLST(GETJPI_ITMLST)	! Get address of itemlist
  
	   IER = SYS$GETJPIW(,,PROCESS(:PLEN),%VAL(GETJPI_ITMLST),,,,)D
	ELSE0
	   CALL INIT_ITMLST	! Initialize item listf
	   CALL ADD_2_ITMLST(4,JPI$_OWNER,%LOC(PROCESS_ID))
	   CALL END_ITMLST(GETJPI_ITMLST)	! Get address of itemlist
 '
	   IER = SYS$GETJPIW(,,,%VAL(GETJPI_ITMLST),,,,)h
	END IF
 0
	IER = SYS$CANCEL(%VAL(TERM_CHAN))
  
	SAVE_KEYPAD_MODE = KEYPAD_MODEe
	IF (KEYPAD_MODE.EQ.0) CALL SET_KEYPAD
 e
	IF (IER) IER = LIB$ATTACH(PROCESS_ID)
	IF (.NOT.IER) CALL SYS_GETMSG(IER)p
 i
	IF (SAVE_KEYPAD_MODE.EQ.0) CALL SET_NOKEYPAD)
 0
	RETURN 
        ENDd
 h
 e
 r
 o
 i
	SUBROUTINE GET_BROADCAST_MESSAGE(RING_BELL)
 s
	IMPLICIT INTEGER (A-Z) 
 &
	INCLUDE 'BULLDIR.INC'
 0
	INCLUDE '($BRKDEF)'
 (
	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT
 D
C_
C  The largest message that can be broadcasted is dependent on systemE
C  and user quotas.  The following limit is 12 lines of ( 80 characters +=
C  CR/LF ) + 2 bells.  This should be more than enough room, as broadcasts
C  shouldn't be too large anyway.l
Ct
  
	PARAMETER CR=CHAR(13),LF=CHAR(10),BELL=CHAR(7)L
 T
	PARAMETER BRDCST_LIMIT = 82*12 + 2D
	CHARACTER*(BRDCST_LIMIT) BROAD 
 $
	COMMON /BROAD_MESSAGE/ BROAD,BLENGTH!
 E
	IF (RING_BELL) THEN	! Include BELL in message?L
	   BROAD(:36) =			! Say who the bulletin is fromU
     &		BELL//BELL//CR//LF//LF//'NEW BULLETIN FROM: '//FROMM
	   BLENGTH = 37			! Start adding next line here
	ELSE 
	   BROAD(:34) =			! Say who the bulletin is fromG
     &		CR//LF//LF//'NEW BULLETIN FROM: '//FROMG
	   BLENGTH = 35			! Start adding next line here
	END IFD
  
	IF (REMOTE_SET) REWIND (UNIT=3)
 R
	END = 0
	ILEN = LINE_LENGTH + 1.
	I = 0
	DO WHILE (ILEN.GT.0)		! Copy bulletin into file
	   IF (REMOTE_SET) THEN
	      READ (3,'(Q,A)',IOSTAT=IER) ILEN,INPUTH
	      IF (IER.NE.0) RETURN 
	   ELSE
	      CALL GET_BULL_LINE(NBLOCK+1,LENGTH,INPUT,ILEN)A
	   END IF
	   IF (ILEN.GT.0) I = I + 1
	   IF (ILEN.GT.0.AND.(I.GT.2.OR.(INPUT(:6).NE.'From: '.AND.
     &			INPUT(:6).NE.'Subj: '))) THEN
	      END = BLENGTH + ILEN - 1 + 2	! Check how long string will beD
	      IF (END.GT.BRDCST_LIMIT) RETURN	! String too long?N
	      BROAD(BLENGTH:END) = CR//LF//INPUT(:ILEN)! Else add new input
	      BLENGTH = END + 1			! Reset pointer
	   END IF
	END DO 
  
	RETURNO
 I
	ENTRY BROADCAST(ALL,CLUSTER)
  
	CALL SYS$SETRWM(%VAL(1))		! Don't wait if can't broadcast
 N
	IF (ALL) THEN				! Should we broadcast to ALL?O
	   IF (CLUSTER) THENT
	      CALL SYS$BRKTHRU(,BROAD(:BLENGTH-1)//CR,,
     &			%VAL(BRK$C_ALLTERMS),,,%VAL(BRK$M_CLUSTER),,,,)
	   ELSE
	      CALL SYS$BRKTHRU(,BROAD(:BLENGTH-1)//CR,,
     &			%VAL(BRK$C_ALLTERMS),,,,,,,) 
	   END IF
	ELSE	 				! Else just broadcast to users.
	   IF (CLUSTER) THENs
	      CALL SYS$BRKTHRU(,BROAD(:BLENGTH-1)//CR,,
     &			%VAL(BRK$C_ALLUSERS),,,%VAL(BRK$M_CLUSTER),,,,)
	   ELSE
	       CALL SYS$BRKTHRU(,BROAD(:BLENGTH-1)//CR,,t
     &			%VAL(BRK$C_ALLUSERS),,,,,,,)i
	   END IF
	END IFd
 o
	CALL SYS$SETRWM(%VAL(0))I
 
	RETURNE
	END
 )
 I
	SUBROUTINE GET_FOLDER_INFO(IER)
CT
C  SUBROUTINE GET_FOLDER_INFOE
CR
C  FUNCTION: Obtains & verifies folder names from command line.o
CI
 I
	IMPLICIT INTEGER (A-Z)
 M
	INCLUDE 'BULLFOLDER.INC'
 M
	EXTERNAL CLI$_ABSENTM
 R
	COMMON /NODE_INFO/ NODES,LOCAL_NODE_FOUND,NODE_NUM,
     &				NODE_ERROR,POINT_NODEQ
	CHARACTER*32 NODES(10) 
	LOGICAL LOCAL_NODE_FOUND,NODE_ERROR
 o
	COMMON /ACCESS/ READ_ONLY
	LOGICAL READ_ONLY
 A
	CHARACTER NODE_TEMP*256
 L
	NODE_NUM = 0				! Initialize number of nodesP
	DO WHILE (CLI$GET_VALUE('SELECT_FOLDER',NODE_TEMP) 
     &	    .NE.%LOC(CLI$_ABSENT))		! Get the specified nodes
	   IER = SYS_TRNLNM(NODE_TEMP,NODE_TEMP) 
	   DO WHILE (TRIM(NODE_TEMP).GT.0)e
	      NODE_NUM = NODE_NUM + 1
	      COMMA = INDEX(NODE_TEMP,',')(
	      IF (COMMA.GT.0) THENi
		 NODES(NODE_NUM) = NODE_TEMP(:COMMA-1)
		 NODE_TEMP = NODE_TEMP(COMMA+1:)
	      ELSE'
		 NODES(NODE_NUM) = NODE_TEMP
		 NODE_TEMP = ' '
	      END IFR
	      NLEN = TRIM(NODES(NODE_NUM)),
	      IF (NODES(NODE_NUM)(NLEN-1:NLEN).EQ.'::') THEN
		 NODES(NODE_NUM) = NODES(NODE_NUM)(:NLEN)//'GENERAL'
	      END IF 
	      FOLDER_NUMBER = -1D
	      FOLDER1 = NODES(NODE_NUM)
	      CALL SELECT_FOLDER(.FALSE.,IER)
	      IF (.NOT.IER) THEN_
		 WRITE (6,'('' Unable to access folder '',A)')
     &				NODES(NODE_NUM)
		 RETURN=
	      ELSE IF (READ_ONLY) THENP
		 WRITE (6,'('' ERROR: No write access for folder '',A)')
     &				NODES(NODE_NUM)E
		 IER = 0
		 RETURNN
	      END IF
	   END DO
	END DOt
 o
	IER = 1
 e
	RETURNT
	END
